<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2012 Thomas Dudzak <thomas.dudzak@gmx.net>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'MediaElements' for the 'mediaelements' extension.
 *
 * @author	Thomas Dudzak <thomas.dudzak@gmx.net>
 * @package	TYPO3
 * @subpackage	tx_mediaelements
 */
class tx_mediaelements_pi1 extends tslib_pibase {
	var $prefixId      	= 'tx_mediaelements_pi1';		// Same as class name
	var $scriptRelPath 	= 'pi1/class.tx_mediaelements_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        	= 'mediaelements';	// The extension key.
	var $pi_checkCHash 	= true;
	var $showPlaylist	= false; 
	var $globalScript	= ''; 
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content, $conf) {
		$globalConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['mediaelements']); 
		$this->globalScript = $globalConf['globalScript']; 
		$this->conf['audio'] = $conf;
		$this->conf['video'] = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->initTsAndFlexformConfig(); 
		if ($this->globalScript!= 1) $this->includeJsAndCss(); 
		if (!empty($this->conf['video']['playlist'])) {
			$items = $this->getPlaylistItems(); 
			$content = $this->renderMediaElement($items); 			
		} 
		
		$out = ''; 
		$out .= !empty($content['content']) ? $content['content'] : ''; 
		$script= !empty($content['script']) ? $content['script'] : '';
		$script .= !empty($content['playlist']) ? $content['playlist'] : '';
		$out .= !empty($script) ? '<script>'.$script.'</script>' : ''; 
		return $this->pi_wrapInBaseClass($out);
	}
	
	/**
	 * The main method of the PlugIn when called by tt_news
	 *
	 * @param	array		$markerArray: Array of markers of current tt_news element
	 * @param	array		$row: database row of current tt_news element
	 * @param	array		$lConf: array of local configuration of tt_news
	 * @param				$pObj: cObj of parent element
	 * @return	The content that is displayed in news article
	 */
	
	function extraItemMarkerProcessor($markerArray, $row, $lConf, &$pObj) {
		$this->cObj = t3lib_div::makeInstance("tslib_cObj");
		
		if ($pObj->config['code'] == 'SINGLE') {
			$conf = array(); 
			if(is_array($GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_mediaelements_pi1.'])) {
				$conf = array_merge($conf, $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_mediaelements_pi1.']);
			}

			if(is_array($lConf['tx_mediaelements.'])) {
				$conf = array_merge($conf, $lConf['tx_mediaelements.']);
			}
			
			$this->conf['audio'] = $conf;
			$this->conf['video'] = $conf;
			
			if(is_array($this->conf['video']['video.'])) {
				$this->conf['video'] = t3lib_div::array_merge_recursive_overrule($this->conf['video'], $this->conf['video']['video.']);
			}
		
			if(is_array($this->conf['audio']['audio.'])) {
				$this->conf['audio'] = t3lib_div::array_merge_recursive_overrule($this->conf['audio'], $this->conf['audio']['audio.']);
			}
			
			$globalConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['mediaelements']); 
			$this->globalScript = $globalConf['globalScript']; 
			if ($this->globalScript!= 1) $this->includeJsAndCss(); 
			
			if(!empty($row['tx_mediaelements_playlist'])) {
				$items =	$this->getNewsPlaylistItems($row['tx_mediaelements_playlist']); 
			}
			
			$i = 0;
			$this->globalCount = 0;
			$style = ''; 
			preg_match_all('/\[mediaelement(.*)\]/', $markerArray['###NEWS_CONTENT###'], $matches);
			foreach($matches[0] AS $key => $value) {
				$file = $matches[0][$key]; 
				$render = array(); 
				if (strpos($file,'youtube.com')!==false OR strpos($file,'youtu.be')!==false OR strpos($file,'vimeo.com')!==false) { 
					preg_match('/src=[ ]?[\'\"](.*)[\'\"]/', str_replace('&quot;', '"', $file), $url);
					//preg_match('/poster=[ ]?[\'\"](.*)[\'\"]/', str_replace('&quot;', '"', $file), $poster);					

					$mediatype = (strpos($file,'vimeo.com')!==false) ? 'vimeo' : 'youtube'; 
					$render[] = array(
									'uid' => $this->globalCount.'ext',
									'mediatype' => $mediatype, 
									'file_url' => trim($url[1]),
					//				'image' => trim($poster[1])
								); 
					$out = $this->renderMediaElement($render, $this->globalCount); 
					$replace = $out['content']; 
					$script .= $out['script'];
				} elseif (is_array($items[$i])){
					$render[] = $items[$i]; 
					$out = $this->renderMediaElement($render, $this->globalCount); 
					$replace = $out['content']; 
					$script .= $out['script'];
					$i++;
				} else {
					$replace = '';   
				}
				$markerArray['###NEWS_CONTENT###'] = preg_replace('/'.str_replace('/','\/' , preg_quote($matches[0][$key])).'/', $replace, $markerArray['###NEWS_CONTENT###'],1);
				$this->globalCount++; 
			}

			$markerArray['###NEWS_CONTENT###'] = !empty($script) ? $markerArray['###NEWS_CONTENT###'].'<script>'.$script.'</script>' : $markerArray['###NEWS_CONTENT###']; 
			
			preg_match_all('/\[mediaelement(.*)\]/', $markerArray['###NEWS_SUBHEADER###'], $matches);
			foreach($matches[0] AS $key => $value) {
				$markerArray['###NEWS_SUBHEADER###'] = str_replace($value,'',$markerArray['###NEWS_SUBHEADER###']); 
			}
			
			
			
			return $markerArray;
		} else {
			// CLEANS UP THE PREVIEW FROM MARKERS IN TEXT
			if(!empty($row['short'])) {
				$teaser = $row['short']; 
			} else {
				$teaser = $row['bodytext']; 
			}
			preg_match_all('/\[mediaelement(.*)\]/', $teaser, $matches);
			foreach($matches[0] AS $key => $value) {
				$teaser = str_replace($value,'',$teaser); 
			}
			$markerArray['###NEWS_SUBHEADER###'] = $pObj->formatStr($this->cObj->stdWrap($teaser, $lConf['subheader_stdWrap.']));
			return $markerArray; 
		}
	}
	
	/**
	 * initialize flexform and compares with configuration array
	 *
	 */
	
	function initTsAndFlexformConfig(){
		$this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
		$this->showPlaylist = $this->conf['video']['showPlaylist']; 
		if($this->pi_getFFvalue($piFlexForm, 'showPlaylist', 's_layout')) {
			$this->showPlaylist = $this->pi_getFFvalue($piFlexForm, 'showPlaylist', 's_layout');
		}
		
		if(is_array($this->conf['video']['video.'])) {
			$this->conf['video'] = t3lib_div::array_merge_recursive_overrule($this->conf['video'], $this->conf['video']['video.']);
		}
		
		if(is_array($this->conf['audio']['audio.'])) {
			$this->conf['audio'] = t3lib_div::array_merge_recursive_overrule($this->conf['audio'], $this->conf['audio']['audio.']);
		}
		 
		$fConf = array();
		if ($piFlexForm['data']) {
			 foreach ( $piFlexForm['data'] as $sheet => $data ) {
			  	foreach ( $data as $lang => $value ) {
			   		foreach ( $value as $key => $val ) {
			   			if(!empty($val['vDEF'])) {
							$fConf[$key] = trim($this->pi_getFFvalue($piFlexForm, $key, $sheet));
						}
			 		}
				}
			}
		}
		 
		$this->conf['video'] = t3lib_div::array_merge_recursive_overrule($this->conf['video'], $fConf); 
		$this->conf['audio'] = t3lib_div::array_merge_recursive_overrule($this->conf['audio'], $fConf); 
		 
		//helper for better development overview
		unset( $this->conf['video']['video.']); 
		unset( $this->conf['video']['audio.']); 
		unset( $this->conf['audio']['video.']); 
		unset( $this->conf['audio']['audio.']); 
	}
	
	/**
	 * includes JS and CSS for player
	 *
	 */
	
	function includeJsAndCss() {
		if($this->conf['video']['jQueryRes']) $this->jsFile[] = $this->conf['video']['jQueryRes'];
		if($this->conf['video']['mediaelementsJSRes']) $this->jsFile[] = $this->conf['video']['mediaelementsJSRes'];
		
		if($this->conf['video']['cssFile']) $this->cssFile[] = $this->conf['video']['cssFile'];
		if($this->conf['video']['cssFilePlaylist']) $this->cssFile[] = $this->conf['video']['cssFilePlaylist'];
		
		if ($GLOBALS['TSFE']->config['config']['moveJsFromHeaderToFooter']) {
			$allJsInFooter = true;
		} else {
			$allJsInFooter = false;
		}
		
		$pagerender = $GLOBALS['TSFE']->getPageRenderer();
		
		if (count($this->jsFile) > 0) {
			foreach ($this->jsFile as $jsToLoad) {
				$file = $GLOBALS['TSFE']->tmpl->getFileName($jsToLoad);
				if ($file) {
					if ($allJsInFooter) {
						$pagerender->addJsFooterFile($file, 'text/javascript', $this->conf['video']['jsMinify']);
					} else {
						$pagerender->addJsFile($file, 'text/javascript', $this->conf['video']['jsMinify']);
					}
				} else {
					t3lib_div::devLog("'{$jsToLoad}' does not exists!", $this->extKey, 2);
				}
			}
		}
		
		if (count($this->cssFile) > 0) {
			foreach ($this->cssFile as $cssToLoad) {
				$css = $GLOBALS['TSFE']->tmpl->getFileName($cssToLoad);
				if ($css) {
					$pagerender->addCssFile($css, 'stylesheet', 'all', '', $this->conf['video']['cssMinify']);
				} else {
					t3lib_div::devLog("'{$cssToLoad}' does not exists!", $this->extKey, 2);
				}
			}
		}
	}
	
	/**
	 * render the media element
	 *
	 * @param	array		$items: items to be rendered
	 * @param	int			$count: needed to set script only once in news article
	 * @return	html source element and script as array
	 */
	function renderMediaElement($items, $count=0) {
		$out = array(); 
		$cUid = $this->cObj->data['uid'] ? $this->cObj->data['uid'] : ''; 
		
		$playerConf['audio'] = $this->setPlayerConfiguration('audio'); 
		$playerConf['video'] = $this->setPlayerConfiguration('video'); 
		
		//thumbs
		$thumbConfig['file.']['width'] = $this->conf['video']['thumbWidth'];
		$thumbConfig['file.']['height'] = $this->conf['video']['thumbheight']; 
		
		$playOE = 0; 		
		$itemsCount = count($items); 	
		
		foreach($items AS $item) {
			$filesource = ''; 
			
			switch ($item['mediatype']) {
				case 2: 
					$item['mediatype'] = 'audio'; 
					break;
				case 3: 
					$item['mediatype'] = 'youtube'; 
					break;					
				case 4: 
					$item['mediatype'] = 'vimeo'; 
					break;		
				default: 
					$item['mediatype'] = 'video'; 
					break;	
			}
					
			$itemtype = $item['mediatype'] == 'audio' ? 'audio' : 'video'; 
			
			// get files for each item 
			if(!empty($item['file'])) {
				$files = t3lib_div::trimExplode(",", $item['file']);
				foreach($files AS $file) {
					$filesource .= !empty($file) ? '<source '.$this->setPseudoMimeType($file, $item['mediatype']).'src="'.$file.'" />' : ''; 
				}
			} 
			
			if(!empty($item['file_url'])) {
				$files = t3lib_div::trimExplode("\n", $item['file_url']);
				foreach($files AS $file) {
					$filesource .= !empty($file) ? '<source '.$this->setPseudoMimeType($file, $item['mediatype']).'src="'.$file.'" />' : ''; 
				}
			}
			
			// render html5 media element
			if(!empty($filesource)) {
				$tracksource = (!empty($item['track']) AND ($item['mediatype']== 'video' OR $item['mediatype']== 'youtube')) ? $this->getTracks($item['track'], $item['track_title']): '';  
				
				if (!empty($item['image'])) {
					$imgConfig['file.']['width'] = !empty($this->conf[$itemtype]['playerWidth']) ? $this->conf[$itemtype]['playerWidth'].'c' : '480c'; 
					$imgConfig['file.']['height'] = !empty($this->conf[$itemtype]['playerHeight']) ? $this->conf[$itemtype]['playerHeight'].'c': '480c'; 
					$imgConfig['file'] = 'uploads/tx_mediaelements/'.$item['image'];
					$poster = $this->cObj->IMG_RESOURCE($imgConfig); 
					if(!empty($poster)) {
						$poster = ' poster="'.$poster.'"'; 
					}
				} else {
					$poster = ''; 
				}
				
				$content .= '
							<div id="tx-mediaelements-c'.$cUid.'-uid'.$item['uid'].'-wrap" class="tx-mediaelements-player">
							<'.$itemtype.' id="tx-mediaelements-c'.$cUid.'-uid'.$item['uid'].'"'.
							$playerConf[$itemtype]['height'].
							$playerConf[$itemtype]['width'].
							$playerConf[$itemtype]['responsive'].
							$playerConf[$itemtype]['controls'].
							$playerConf[$itemtype]['autoplay'].
							$playerConf[$itemtype]['preload'].
							$playerConf[$itemtype]['loop'].
							$playerConf[$itemtype]['muted'].
							$poster.
							'>'.$filesource.$tracksource.'</'.$itemtype.'></div>'; 
				
				// render media element playlist item if nessecary
				if($this->showPlaylist AND $this->showPlaylist != 'false' AND $itemsCount > 1) {	
					$playOE++; 
					$oddeven = ($playOE%2== 0) ? 'even' : 'odd';
					$playlist.= '<a rel="tx-mediaelements-c'.$cUid.'-uid'.$item['uid'].'" class="'.$oddeven.'">';
					
					if($item['image']) {
						$thumbConfig['file.']['width'] = '70c';
						$thumbConfig['file.']['height'] = '70c';
						$thumbConfig['file'] = 'uploads/tx_mediaelements/'.$item['image'];
						$playlist .= $this->cObj->IMAGE($thumbConfig); 				
					}
					
					$playlist.= $item['title'] ? '<h6>'.$item['title'].'</h6>' : ''; 
					$playlist.= $item['description'] ? '<p>'.strip_tags($item['description']).'</p>' : ''; 
					$playlist.= $item['author'] ? '<p class="author">Autor: '.strip_tags($item['author']).'</p>' : ''; 
					$playlist.=	'<div style="clear:left;"></div></a>'; 
				}
			}			
		}
		
		//set script to content
		if($count == 0 AND $this->globalScript != 1) {
			$out['script'] = '
				$(\'#tx-mediaelements-c'.$cUid.'-player audio,video\').mediaelementplayer({
					success:  function (mediaElement, domObject) { 
						mediaElement.addEventListener("ended", function(e){ 
							// Revert to the poster image when ended
							var $thisMediaElement = (mediaElement.id) ? jQuery("#"+mediaElement.id) : jQuery(mediaElement);
							$thisMediaElement.parents(".mejs-inner").find(".mejs-poster").show();
						});
					}
				});
				
				if(navigator.userAgent.match(/(iPhone|iPod|iPad)/i) != null) 
				{
					$(\'head\').append(\'<style type="text/css"><!-- .mejs-overlay-play,.mejs-poster {display: none;}--></style>\'); 
				}
			'; 
		}
		
		//set playlist to content
		if(!empty($this->conf['video']['playlistHeight'])) {
			$playlistHeight = ' style="height: '.$this->conf['video']['playlistHeight'].'px"'; 
		}
		
		if(!empty($this->conf['video']['containerWidth']) AND ($this->conf['video']['responsiveDesign'] == 'false' OR $this->conf['video']['responsiveDesign'] == false)) {
			$containerWidth = ' style="width: '.$this->conf['video']['containerWidth'].'px"'; 
		} 
		
		if ($this->showPlaylist == 'bottom' && !empty($playlist)) {
			$content = $content.'<div class="playlist" id="tx-mediaelements-c'.$cUid.'-playlist"'.$playlistHeight.'>'.$playlist.'</div>'; 
		} elseif ($this->showPlaylist == 'top' && !empty($playlist)) {
			$content = '<div class="playlist" id="tx-mediaelements-c'.$cUid.'-playlist scroll-pane"'.$playlistHeight.'>'.$playlist.'</div>'.$content; 
		}
		
		// set playlist script to content 
		if(!empty($playlist)) {
			$out['playlist'] = '
				$(\'#tx-mediaelements-c'.$cUid.'-player\').children(\'.tx-mediaelements-player\').hide();
				$(\'#tx-mediaelements-c'.$cUid.'-player\').children(\'.tx-mediaelements-player:first\').show();
				
				$(\'#tx-mediaelements-c'.$cUid.'-playlist a\').click(function() {
					var item = $(this).attr("rel"); 
					$(\'#tx-mediaelements-c'.$cUid.'-player\').children(\'.tx-mediaelements-player\').hide(); 
					$(\'#\' + item + \'-wrap\').show(); 
					$(\'#\' + item + \'-wrap video,audio\')[0].player.play()
				});
			'; 
		}
		
		$out['content'] = '<div id="tx-mediaelements-c'.$cUid.'-player"'.$containerWidth.'>'.$content.'</div>';
		
		return $out; 
	}
	
	/**
	 * set the player configuration for audio and video 
	 *
	 * @param	string		$type: audio or video
	 * @return	player configuration array
	 */
	
	function setPlayerConfiguration($type) {
		$out['width'] = ($this->conf[$type]['playerWidth']) ? ' width="'.$this->conf[$type]['playerWidth'] .'"' : ''; 
		$out['height'] = ($this->conf[$type]['playerHeight']) ? ' height="'.$this->conf[$type]['playerHeight'] .'" ' : ''; 
		if ($this->conf[$type]['responsiveDesign'] AND $this->conf[$type]['responsiveDesign'] != 'false') {
			$out['responsive'] = ' style="width: 100%; height: 100%;"'; 
		}
		
		// BEHAVIOUR
		$out['controls'] = ($this->conf[$type]['controls'] AND $this->conf[$type]['controls'] != 'false') ? ' controls="controls"' : ''; 
		$out['autoplay'] = ($this->conf[$type]['autoplay'] AND $this->conf[$type]['autoplay'] != 'false') ? ' autoplay' : '';
		$out['preload'] = ($this->conf[$type]['preload'] AND $this->conf[$type]['preload'] != 'false') ? ' preload' : ''; 
		$out['loop'] = ($this->conf[$type]['loop'] AND $this->conf[$type]['loop'] != 'false') ? ' loop' : ''; 
		$out['muted'] = ($type == 'video' AND $this->conf[$type]['muted'] AND $this->conf[$type]['muted'] != 'false') ? ' muted' : '';
		
		return $out; 
	}
	
	/**
	 * Get the playlist items related to plugin 
	 *
	 * @return	item array
	 */
	 
	function getPlaylistItems() {
		$pages = '';
		$elements = ''; 
		$ip= 0; 
		$ie=0; 
		$pageArray = array(); 
		
		$files = t3lib_div::trimExplode(',',$this->conf['video']['playlist'],1);
		foreach($files as $file)	{
			list($table, $id) = t3lib_div::revExplode('_', $file, 2);
			if ($table === 'pages') {
				$pages .= $ip>0 ? ','.$id : $id;  
				$ip++; 
				$pageArray[] = $id; 
			} else {
				$elements .= $ie>0 ? ','.$id : $id; 
				$ie++; 
			}
		}
		
		$where = !empty($elements) ? 'uid IN ('.$elements.')' : '';
		$where .= (!empty($elements) AND !empty($pages)) ? ' OR ' : ''; 
		$where .= !empty($pages) ? 'pid IN ('.$pages.')' : ''; 
		$where .= ' '.$this->cObj->enableFields('tx_mediaelements_item'); 
	
		$res = 	$GLOBALS['TYPO3_DB']->exec_SELECTquery(
				'*', 
				'tx_mediaelements_item', 
				$where,
				'sorting'
				);
				
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			if (in_array($row['pid'], $pageArray)) {
				$items['page_'.$row['pid']][] = $row;
			} else {
				$items['element_'.$row['uid']] = $row; 
			}
		}
		
		if(!empty($items)) {
			foreach($files as $file)	{
				list($table, $id) = t3lib_div::revExplode('_', $file, 2);
				if($table === 'pages' AND is_array($items['page_'.$id])) {
					foreach($items['page_'.$id] AS $key => $value) {
						$itemout[] = $value; 
					}
				} elseif(is_array($items['element_'.$id])) {
					$itemout[] = $items['element_'.$id]; 
				}
			}
		}
			
		return $itemout; 
	}
	
	/**
	 * Get the playlist items related to news article
	 *
	 * @param	string		$itemlist: comma-seperated list of related items by uid
	 * @return	item array
	 */
	
	function getNewsPlaylistItems($itemlist) {
		$where =	'tx_mediaelements_item.uid IN ('.$itemlist.')'; 
		$where .=	$this->cObj->enableFields('tx_mediaelements_item'); 

		$res = 	$GLOBALS['TYPO3_DB']->exec_SELECTquery(
				'*', 
				'tx_mediaelements_item', 
				$where,
				'sorting'
				);
				
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$items[] = $row; 
		}
		
		return $items; 
	}
	
	/**
	 * get the track files for current file
	 *
	 * @param	string		$itemTrack: the filepath for trackfiles
	 * @param	string		$itemTrackTitle: the title of the track
	 * @return	html source for track element
	 */
	 
	function getTracks($itemTrack, $itemTrackTitle) {
		$tracksource = ''; 
		$tracks = t3lib_div::trimExplode(",", $itemTrack);
		$trackTitles = t3lib_div::trimExplode("\n", $itemTrackTitle);
					
		foreach($tracks AS $key => $track) {
			if(!empty($trackTitles[$key])) {
				$trackArray	= t3lib_div::trimExplode("|", $trackTitles[$key]);
				if($trackArray[1]) {
					$srclang = $trackArray[1]; 
				} elseif($this->conf['video']['defaultSrcLang']) {
					$srclang = trim($this->conf['video']['defaultSrcLang']); 
				} else {
					$srclang = 'en'; 
				}
			
				$trackTitle = ' label="'.$trackArray[0].'" srclang="'.$srclang.'"'; 
			} else {
				$defaultSrcLang = $this->conf['video']['defaultSrcLang'] ? trim($this->conf['video']['defaultSrcLang']) : 'en'; 
				$defaultTrack = $this->conf['video']['defaultTrackLabel'] ? trim($this->conf['video']['defaultTrackLabel']) : 'English'; 
				$trackTitle = ' label="'.$defaultTrack.'" srclang="'.$defaultSrcLang.'"';
			}
			
			$tracksource .= !empty($track) ? '<track kind="subtitles" src="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').$track.'"'.$trackTitle.'/>' : ''; 
			
		}
		return $tracksource; 
	}
	
	/**
	 * Sets a pseudo-MIME-TYPE for 
	 *
	 * @param	string		$file: the filepath
	 * @param	string		$format: video or audio
	 * @return	The Pseudo-MIME-TYPE of the file, leaves empty if no match
	 */
	function setPseudoMimeType($file, $format='video') {
		$mime = '';
		
		if ($format == 'youtube') {
			$mime = 'video/youtube'; 
		} elseif($format == 'vimeo') {
			$mime = 'video/vimeo'; 
		} else {
			$extension = pathinfo($file,PATHINFO_EXTENSION); 
		
			switch($extension) {
				case 'flv': 
					$mime = $format.'/flv'; 
					break; 
				case 'webm':
					$mime = $format.'/webm'; 
					break;
				case 'ogg':
					$mime = $format.'/ogg'; 
					break; 
				case 'mpeg':
					$mime = $format.'/mpeg'; 
					break; 
				case 'mp4':
					$mime = $format.'/mp4';
					break; 
			}
					
			if ($format=='video' AND empty($mime)) {
				switch($extension) {
					case 'm4v':
						$mime = 'video/m4v'; 
						break; 
					case 'mov':
						$mime = 'video/mov'; 
						break; 
					case 'rtmp':
						$mime = 'video/rtmp'; 
						break; 
					case 'ogv':
						$mime = 'video/ogg'; 
						break;
				}
			} elseif ($format=='audio' AND empty($mime)) {
				switch($extension) {
					case 'aac': 
						$mime = 'audio/aac'; 
						break; 
					case 'mp1':
						$mime = 'audio/mpeg'; 
						break; 
					case 'mp2': 
						$mime = 'audio/mpeg'; 
						break; 
					case 'mp3':
						$mime = 'audio/mpeg'; 
						break; 
					case 'mpg': 
						$mime = 'audio/mpeg'; 
						break;
					case 'm4a':
						$mime = 'audio/mp4';
						break; 
					case 'oga':
						$mime = 'audio/ogg';
						break;
					case 'wav': 
						$mime = 'audio/wav';
						break;
				}
			}
			// fallback if youtube or vimeo are set wrong
			if ($format=='video') {
				if(strpos($file,'youtube.com')!==false OR strpos($file,'youtu.be')!==false) { $mime = 'video/youtube'; }
				else if(strpos($file,'vimeo.com')!==false) { $mime = 'video/vimeo'; }
			}
		}

		if (!empty($mime)) {
			return 'type="'.$mime.'" ';
		} else {
			return; 
		}
	}
	
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mediaelements/pi1/class.tx_mediaelements_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mediaelements/pi1/class.tx_mediaelements_pi1.php']);
}
?>